/**
  ********************************************************
  * File Name          : My_Util.c
  * Description        : 
	********************************************************
 */

#include "stm32f1xx_hal.h"
#include "SEGGER_RTT.h"
#include "My_Util.h"
extern RTC_HandleTypeDef hrtc;
uint16_t count1;
uint16_t count2;
//*********************************************************************************
void HAL_SYSTICK_Callback(void)
{
	if (count1>0) count1--;
	else
	{
		HAL_GPIO_TogglePin(LED_RED_GPIO_Port, LED_RED_Pin);
		count1=500;
	}
	if (count2>0) count2--;	
};
//*********************************************************************************

void Delay_ms(uint16_t ms)
{
count2 = ms;
while (count2)
  {
  }	
};
//*********************************************************************************
void RTC_CalendarShow(void)
{
  RTC_DateTypeDef sdatestructureget;
  RTC_TimeTypeDef stimestructureget;

  /* Get the RTC current Time */
  HAL_RTC_GetTime(&hrtc, &stimestructureget, RTC_FORMAT_BIN);
  /* Get the RTC current Date */
  HAL_RTC_GetDate(&hrtc, &sdatestructureget, RTC_FORMAT_BIN);
  /* Display time Format : hh:mm:ss */
	SEGGER_RTT_printf(0, "Time: %2d:%2d:%2d ",stimestructureget.Hours, stimestructureget.Minutes, stimestructureget.Seconds);	
 
  /* Display date Format : mm-dd-yy */
	SEGGER_RTT_printf(0, "  Date:%2d-%2d-%2d \r\n", sdatestructureget.Date,sdatestructureget.Month,  2000 + sdatestructureget.Year);	
  
}
//*********************************************************************************
 void HAL_RTCEx_RTCEventCallback(RTC_HandleTypeDef *hrtc)
 {
 //SEGGER_RTT_SetTerminal(1);
 RTC_CalendarShow();
 //SEGGER_RTT_SetTerminal(0);
 };
/*************************** End of file ****************************/
